typedef struct {
	unsigned char key[32];
	unsigned int ks_enc[60], ks_dec[60];
} aes_key;

void aes_init(aes_key *key);
void aes_close(aes_key *key);
void aes_encrypt_sw(aes_key *key, unsigned char *buffer);
void aes_encrypt_hw(aes_key *key, unsigned char *buffer);
void aes_decrypt_sw(aes_key *key, unsigned char *buffer);
void aes_decrypt_hw(aes_key *key, unsigned char *buffer);

void (*aes_encrypt)(aes_key *key, unsigned char *buffer);
void (*aes_decrypt)(aes_key *key, unsigned char *buffer);