#include <intrin.h>

typedef struct {
	unsigned char key[32];
	__m128i key_enc[15], key_dec[15];
} aes_hw_key;

int aes_ni;

void aes_hw_init(aes_hw_key *key);
void aes_hw_close(aes_hw_key *key);
void aes_hw_encrypt(aes_hw_key *key, unsigned char *buffer);
void aes_hw_decrypt(aes_hw_key *key, unsigned char *buffer);
